%define 		packname jakarta-tomcat-%{version}-src

Summary: 		tomcat jserv&jk modules for apache
Name: 			tomcat-mod
Version: 		3.2.1
Release:	 	1
Vendor: 		Apache Software Foundation
Group: 			System Environment/Daemons
Copyright: 		Apache
Url: 			http://jakarta.apache.org
Provides: 		mod_jserv, mod_jk
Requires: 		apache, ed
BuildRequires: 	apache-devel
Source: 		http://jakarta.apache.org/builds/tomcat/release/v%{version}/src/%{packname}.tar.gz
Source1: 		mod_jk.conf
Source2: 		workers.properties
Patch:			tomcat-mod-3.2.1.patch
BuildRoot: 		/var/tmp/%{name}-root
Obsoletes: 		tomcat-jserv
Packager: 		Henri Gomez <hgomez@slib.fr>

%description
mod_jserv and mod_jk support for apache

%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}
%setup -c -T -a 0
%patch

%build

# jserv module
cd %{packname}
cd src/native/apache/jserv
/usr/sbin/apxs -c -o mod_jserv.so *.c

# jk module
cd ../../apache1.3
make -f Makefile.linux

%install

mkdir -p $RPM_BUILD_ROOT/etc/tomcat/conf
mkdir -p $RPM_BUILD_ROOT/var/log/tomcat
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf

# mod_jserv and mod_jk
cd %{packname}
install src/native/apache/jserv/mod_jserv.so $RPM_BUILD_ROOT/usr/lib/apache/mod_jserv_tomcat.so
install src/native/apache1.3/mod_jk.so $RPM_BUILD_ROOT/usr/lib/apache/mod_jk.so
install %{SOURCE1} $RPM_BUILD_ROOT/etc/httpd/conf
install %{SOURCE2} $RPM_BUILD_ROOT/etc/httpd/conf

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}

%post

if [ -f /etc/httpd/conf/httpd.conf ] ; then
# 6.2 std apache layout
    if ! grep -q '.*LoadModule *jk_module *modules/mod_jk.so' /etc/httpd/conf/httpd.conf ; then
        sed "s|^\LoadModule *rewrite_module *modules/mod_rewrite.so\$|LoadModule jk_module       modules/mod_jk.so\\
LoadModule rewrite_module     modules/mod_rewrite.so|" < /etc/httpd/conf/httpd.conf > /etc/httpd/conf/httpd.conf-
        mv -f /etc/httpd/conf/httpd.conf- /etc/httpd/conf/httpd.conf
    fi
# mod_ssl apache layout
    if ! grep -q '.*LoadModule *jk_module *lib/apache/mod_jk.so' /etc/httpd/conf/httpd.conf ; then
        sed "s|^\LoadModule *rewrite_module *lib/apache/mod_rewrite.so\$|LoadModule jk_module       lib/apache/mod_jk.so\\
LoadModule rewrite_module     lib/apache/mod_rewrite.so|" < /etc/httpd/conf/httpd.conf > /etc/httpd/conf/httpd.conf-
        mv -f /etc/httpd/conf/httpd.conf- /etc/httpd/conf/httpd.conf
    fi

    if ! grep -q '.*AddModule *mod_jk.c' /etc/httpd/conf/httpd.conf ; then
      sed "s|^\AddModule *mod_rewrite.c\$|AddModule mod_jk.c\\
AddModule mod_rewrite.c|" < /etc/httpd/conf/httpd.conf > /etc/httpd/conf/httpd.conf-
        mv -f /etc/httpd/conf/httpd.conf- /etc/httpd/conf/httpd.conf
    fi

    if ! grep -q '.*Include /etc/tomcat/conf/tomcat.conf' /etc/httpd/conf/httpd.conf ; then
        cat >>/etc/httpd/conf/httpd.conf<<EOT
<IfModule mod_jk.c>
Include /etc/httpd/conf/mod_jk.conf
</IfModule>
EOT
    fi
fi

%preun 
if [ $1 = 0 ]; then
# remove existing map if any
	sed -e '/^Include \usr\/tomcat\/conf\/tomcat.conf/d' \
        -e '/^ApJServLogFile \/var\/log\/httpd\/mod_jk.log/d' \
        -e '/^LoadModule jk_module lib\/apache\/mod_jk.so/d' \
        -e '/^AddModule mod_jk.c/d' \
      < /etc/httpd/conf/httpd.conf \
      > /etc/httpd/conf/httpd.conf-
  	mv /etc/httpd/conf/httpd.conf- \
     	/etc/httpd/conf/httpd.conf

	rm -f /etc/logrotate.d/tomcat
fi

%files
%attr( - ,root,root)						/usr/lib/apache/*
%attr(644,root,root)  %config(noreplace) 	/etc/httpd/conf/mod_jk.conf
%attr(644,root,root)  %config(noreplace)	/etc/httpd/conf/workers.properties

%changelog
* Thu Dec 14 2000 Henri Gomez <hgomez@slib.fr>
- v3.2.1 release
- added Dan Milstein patch (Multipart stream error on ajp13)

* Fri Nov 30 2000 Henri Gomez <hgomez@slib.fr>
- v3.2 official release
- at least, it's arrived, it's there
- Compiled on Redhat 6.1 with apache 1.3.14 and mod_ssl 2.7.1 (EAPI)

* Tue Nov 21 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-8 RPM

* Mon Nov 13 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-7 RPM

* Thu Oct 12 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-6 RPM
- removed make&mod_jk since they're now included in distro 

* Mon Oct 09 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-5 RPM release 2
- clean up doc

* Mon Sep 25 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-5 RPM

* Thu Sep 14 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-4 RPM
- corrected documentations

* Thu Sep 14 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3 RPM release 4
- added latest mod_jk patch

* Mon Sep 11 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3 RPM release 3
- Recompiled on Redhat 6.1 for a i386 target
- Signed with my pgp key.

* Fri Sep 08 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3 RPM release 2
- new release for my birthday ;-)
- Using mod_jk patch from saurik & me (saurik.com)
- Compiled on Redhat 6.2 with apache 1.3.12 and mod_ssl 2.6.6 (EAPI)

* Fri Sep 01 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3

* Thu Jul 27 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-2
- Initial RPM for v3.2-beta-2 modules
- mod_jk and mod_jserv are both included but mod_jk is installed
  by default since it support apj12/apj13 and SSL stuffs.
- mod_jserv.so is renamed mod_jserv_tomcat.so to
  avoid collision with Apache JServ module mod_jserv.so.
- Compiled on Redhat 6.1 with apache 1.3.12 and mod_ssl 2.6.5 (EAPI)

